<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: llg/precond.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_ad11b878d2835527517911859427b54f.html">llg</a>
  </div>
</div>
<div class="contents">
<h1>precond.c</h1><a href="precond_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: precond.c 3013 2010-03-26 16:12:31Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="llg_8h.html">llg.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field/field.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">static</span> KSP  ksp_Jac; 
<a name="l00032"></a>00032 <span class="keyword">static</span> Mat  vode_Jac; 
<a name="l00033"></a>00033 <span class="keyword">static</span> Vec  vode_w1,vode_w2; 
<a name="l00034"></a>00034 <span class="keyword">static</span> Mat  vode_pmat; 
<a name="l00036"></a><a class="code" href="precond_8c.html#a811a9e1276828ec4cf472f954d12b1fc">00036</a> <span class="keywordtype">int</span> <a class="code" href="precond_8c.html#a811a9e1276828ec4cf472f954d12b1fc">Precond_Init</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040   <span class="keywordtype">int</span> rank,size;
<a name="l00041"></a>00041   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00042"></a>00042   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Calculating sparsity pattern for matrix preallocation\n&quot;</span>);
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   <span class="comment">/* get ownership range */</span>
<a name="l00047"></a>00047   <span class="keywordtype">int</span> low,high;
<a name="l00048"></a>00048   ierr = VecGetOwnershipRange(gdata-&gt;<a class="code" href="structGridData.html#a6415aba4002f4be8541f8f1ee7b9391d">elevol</a>,&amp;low,&amp;high);CHKERRQ(ierr);
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="keywordtype">int</span> *elevertall;
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="preprocessor">#ifdef HAVE_ELEVERTALL</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span>  elevertall=gdata-&gt;elevertall;
<a name="l00054"></a>00054 <span class="preprocessor">#else</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (size&gt;1) {
<a name="l00056"></a>00056     ierr = PetscMalloc(<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;elevertall);CHKERRQ(ierr);
<a name="l00057"></a>00057     ierr = PetscMemcpy(elevertall+<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*low,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));CHKERRQ(ierr);
<a name="l00058"></a>00058 
<a name="l00059"></a>00059     <span class="keywordtype">int</span> *p;
<a name="l00060"></a>00060     p=elevertall;
<a name="l00061"></a>00061 
<a name="l00062"></a>00062     <span class="keywordtype">int</span> recvcount[size];
<a name="l00063"></a>00063     recvcount[rank]=<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>;
<a name="l00064"></a>00064     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;size;i++) {
<a name="l00065"></a>00065       ierr = MPI_Bcast(recvcount+i,1,MPI_INT,i,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00066"></a>00066       <span class="comment">/* we could also use MPI_Send/Recv to get everything just to the first processor */</span>
<a name="l00067"></a>00067       ierr = MPI_Bcast(p,recvcount[i],MPI_INT,i,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00068"></a>00068       p+=recvcount[i];
<a name="l00069"></a>00069     }
<a name="l00070"></a>00070     assert(p==elevertall+<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>);
<a name="l00071"></a>00071   }
<a name="l00072"></a>00072   <span class="keywordflow">else</span> {
<a name="l00073"></a>00073     elevertall=gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>;
<a name="l00074"></a>00074   }
<a name="l00075"></a>00075 <span class="preprocessor">#endif</span>
<a name="l00076"></a>00076 <span class="preprocessor"></span>
<a name="l00077"></a>00077   <span class="keywordtype">int</span> *ia,*ja;
<a name="l00078"></a>00078 <span class="preprocessor">#ifdef HAVE_M2IJ</span>
<a name="l00079"></a>00079 <span class="preprocessor"></span>  ia=gdata-&gt;mesh2nodal_ia;
<a name="l00080"></a>00080   ja=gdata-&gt;mesh2nodal_ja;
<a name="l00081"></a>00081 <span class="preprocessor">#else</span>
<a name="l00082"></a>00082 <span class="preprocessor"></span>  ierr = <a class="code" href="mesh2dual_8c.html#abb99aec57817a85ad1c4c2552f695434">Mesh2Nodal</a>(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,elevertall,&amp;ia,&amp;ja);CHKERRQ(ierr);
<a name="l00083"></a>00083 <span class="preprocessor">#endif</span>
<a name="l00084"></a>00084 <span class="preprocessor"></span>
<a name="l00085"></a>00085 <span class="preprocessor">#ifndef HAVE_ELEVERTALL</span>
<a name="l00086"></a>00086 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (size&gt;1) {
<a name="l00087"></a>00087     ierr = PetscFree(elevertall);CHKERRQ(ierr);
<a name="l00088"></a>00088   }
<a name="l00089"></a>00089 <span class="preprocessor">#endif</span>
<a name="l00090"></a>00090 <span class="preprocessor"></span>
<a name="l00091"></a>00091   <span class="comment">/* get ownership range */</span>
<a name="l00092"></a>00092   ierr = VecGetOwnershipRange(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;low,&amp;high);CHKERRQ(ierr);
<a name="l00093"></a>00093   low/=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00094"></a>00094   high/=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   <span class="keywordtype">int</span> *d_nnz;
<a name="l00097"></a>00097   <span class="keywordtype">int</span> *o_nnz;
<a name="l00098"></a>00098   ierr = PetscMalloc(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*(high-low)*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;d_nnz);CHKERRQ(ierr);
<a name="l00099"></a>00099   ierr = PetscMalloc(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*(high-low)*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;o_nnz);CHKERRQ(ierr);
<a name="l00100"></a>00100   <span class="comment">/* calculate number of nonzeroes for each line */</span>
<a name="l00101"></a>00101   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=low;i&lt;high;i++) {
<a name="l00102"></a>00102     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;j++) {
<a name="l00103"></a>00103       d_nnz[ND*(i-low)+j]=ND;
<a name="l00104"></a>00104       o_nnz[ND*(i-low)+j]=0;
<a name="l00105"></a>00105       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> l=ia[i];l&lt;ia[i+1];l++) {
<a name="l00106"></a>00106         <span class="keywordflow">if</span> (ja[l]&gt;=low &amp;&amp; ja[l]&lt;high) {
<a name="l00107"></a>00107           d_nnz[ND*(i-low)+j]+=ND;
<a name="l00108"></a>00108         }
<a name="l00109"></a>00109         <span class="keywordflow">else</span> {
<a name="l00110"></a>00110           o_nnz[ND*(i-low)+j]+=ND;
<a name="l00111"></a>00111         }
<a name="l00112"></a>00112       }
<a name="l00113"></a>00113     }
<a name="l00114"></a>00114   }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 <span class="preprocessor">#if 0</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span><span class="preprocessor">#define PREALLOC_DG 25</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span><span class="preprocessor">#define PREALLOC_OD 15</span>
<a name="l00119"></a>00119 <span class="preprocessor"></span>  PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Creating matrix with fixed preallocation\n&quot;</span>);
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   ierr = MatCreateMPIAIJ(
<a name="l00122"></a>00122     PETSC_COMM_WORLD,
<a name="l00123"></a>00123     <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,
<a name="l00124"></a>00124     <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,
<a name="l00125"></a>00125     <a class="code" href="hexch__ani_8c.html#ae33fb5e4bf8cbe9e2361e84f29a77d35">PREALLOC_DG</a>,0,<a class="code" href="hexch__ani_8c.html#a466793c34bde5662dfab48310c5c42e2">PREALLOC_OD</a>,0,
<a name="l00126"></a>00126     &amp;vode_Jac
<a name="l00127"></a>00127   );CHKERRQ(ierr);
<a name="l00128"></a>00128 <span class="preprocessor">#else</span>
<a name="l00129"></a>00129 <span class="preprocessor"></span>  PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Creating matrix with calculated preallocation\n&quot;</span>);
<a name="l00130"></a>00130   ierr = MatCreateMPIAIJ(
<a name="l00131"></a>00131     PETSC_COMM_WORLD,
<a name="l00132"></a>00132     <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,
<a name="l00133"></a>00133     <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,
<a name="l00134"></a>00134     0,d_nnz,0,o_nnz,
<a name="l00135"></a>00135     &amp;vode_Jac
<a name="l00136"></a>00136   );CHKERRQ(ierr);
<a name="l00137"></a>00137 <span class="preprocessor">#endif</span>
<a name="l00138"></a>00138 <span class="preprocessor"></span>  ierr = MatSetFromOptions(vode_Jac);CHKERRQ(ierr);
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 <span class="preprocessor">#ifndef HAVE_M2IJ</span>
<a name="l00141"></a>00141 <span class="preprocessor"></span>  ierr = PetscFree(ia);CHKERRQ(ierr);
<a name="l00142"></a>00142   ierr = PetscFree(ja);CHKERRQ(ierr);
<a name="l00143"></a>00143 <span class="preprocessor">#endif</span>
<a name="l00144"></a>00144 <span class="preprocessor"></span>  ierr = PetscFree(d_nnz);CHKERRQ(ierr);
<a name="l00145"></a>00145   ierr = PetscFree(o_nnz);CHKERRQ(ierr);
<a name="l00146"></a>00146 
<a name="l00147"></a>00147   ierr = VecCreateMPIWithArray(PETSC_COMM_WORLD,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,PETSC_NULL,&amp;vode_w1);CHKERRQ(ierr);
<a name="l00148"></a>00148   ierr = VecCreateMPIWithArray(PETSC_COMM_WORLD,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,PETSC_NULL,&amp;vode_w2);CHKERRQ(ierr);
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Calculating matrix elements...\n&quot;</span>);
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>;i++) {
<a name="l00153"></a>00153     <span class="comment">/* add 0 to diagonal matrix elements to enforce their allocation</span>
<a name="l00154"></a>00154 <span class="comment">       otherwise there might occur problems with MatScale/MatShift in Precond</span>
<a name="l00155"></a>00155 <span class="comment">       due to DIFFERENT_NONZERO_PATTERN</span>
<a name="l00156"></a>00156 <span class="comment">    */</span>
<a name="l00157"></a>00157 
<a name="l00158"></a>00158     <span class="keywordtype">int</span> rows[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00159"></a>00159     rows[0]=gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i]*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00160"></a>00160     rows[1]=rows[0]+1;
<a name="l00161"></a>00161     rows[2]=rows[0]+2;
<a name="l00162"></a>00162 
<a name="l00163"></a>00163     ierr = MatSetValue(vode_Jac,rows[0],rows[0],0.0,ADD_VALUES);CHKERRQ(ierr);
<a name="l00164"></a>00164     ierr = MatSetValue(vode_Jac,rows[1],rows[1],0.0,ADD_VALUES);CHKERRQ(ierr);
<a name="l00165"></a>00165     ierr = MatSetValue(vode_Jac,rows[2],rows[2],0.0,ADD_VALUES);CHKERRQ(ierr);
<a name="l00166"></a>00166   }
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   <span class="comment">/* compute the Jacobian */</span>
<a name="l00169"></a>00169   MatStructure str2 = DIFFERENT_NONZERO_PATTERN;
<a name="l00170"></a>00170   ierr = <a class="code" href="llg_8h.html#a35010647607c93a40bdab3e86041714f">myLLGJacobian</a>(PETSC_NULL,gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;vode_Jac,&amp;vode_Jac,&amp;str2,gdata);CHKERRQ(ierr);
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   ierr = MatDuplicate(vode_Jac,MAT_DO_NOT_COPY_VALUES,&amp;vode_pmat);CHKERRQ(ierr);
<a name="l00173"></a>00173 <span class="preprocessor">#ifdef SUPERLUX</span>
<a name="l00174"></a>00174 <span class="preprocessor"></span>  ierr = MatConvert(vode_Jac,MATSUPERLU_DIST,&amp;vode_Jac);CHKERRQ(ierr);
<a name="l00175"></a>00175   ierr = MatConvert(vode_pmat,MATSUPERLU_DIST,&amp;vode_pmat);CHKERRQ(ierr);
<a name="l00176"></a>00176   ierr = MatDestroy(vode_Jac);CHKERRQ(ierr);
<a name="l00177"></a>00177 <span class="preprocessor">#endif</span>
<a name="l00178"></a>00178 <span class="preprocessor"></span>
<a name="l00179"></a>00179   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Initializing linear solver...\n&quot;</span>);
<a name="l00180"></a>00180 
<a name="l00181"></a>00181   ierr = KSPCreate(PETSC_COMM_WORLD,&amp;ksp_Jac);CHKERRQ(ierr);
<a name="l00182"></a>00182   ierr = KSPSetOperators(ksp_Jac,vode_Jac,vode_Jac,SAME_PRECONDITIONER);CHKERRQ(ierr);
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   <span class="comment">/* set default options */</span>
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   <span class="comment">/* evaluates</span>
<a name="l00187"></a>00187 <span class="comment">      PetscOptions &quot;-psolve_ksp_type&quot;</span>
<a name="l00188"></a>00188 <span class="comment">      PetscOptions &quot;-psolve_ksp_atol&quot;</span>
<a name="l00189"></a>00189 <span class="comment">      PetscOptions &quot;-psolve_ksp_divtol&quot;</span>
<a name="l00190"></a>00190 <span class="comment">      PetscOptions &quot;-psolve_ksp_rtol&quot;</span>
<a name="l00191"></a>00191 <span class="comment">                   &quot;-psolve_pc_type&quot;</span>
<a name="l00192"></a>00192 <span class="comment">                   &quot;-psolve_sub_pc_type&quot;</span>
<a name="l00193"></a>00193 <span class="comment">                   &quot;-psolve_sub_pc_factor_shift_positive_definite&quot;</span>
<a name="l00194"></a>00194 <span class="comment">                   &quot;-psolve_pc_type&quot;</span>
<a name="l00195"></a>00195 <span class="comment">                   &quot;-psolve_pc_factor_shift_positive_definite&quot;</span>
<a name="l00196"></a>00196 <span class="comment">  */</span>
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   PetscTruth flg;
<a name="l00199"></a>00199   <span class="keywordtype">char</span> str[256];
<a name="l00200"></a>00200   <span class="comment">/* by default use conjugate gradient solver */</span>
<a name="l00201"></a>00201 <span class="preprocessor">#undef ostr</span>
<a name="l00202"></a>00202 <span class="preprocessor"></span><span class="preprocessor">#define ostr &quot;-psolve_ksp_type&quot;</span>
<a name="l00203"></a>00203 <span class="preprocessor"></span>  ierr = PetscOptionsGetString(PETSC_NULL,<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str,256,&amp;flg);CHKERRQ(ierr);
<a name="l00204"></a>00204   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00205"></a>00205     sprintf(str,<span class="stringliteral">&quot;gmres&quot;</span>);
<a name="l00206"></a>00206     PetscOptionsSetValue(<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str);
<a name="l00207"></a>00207     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Option %s not found, using default value %s!\n&quot;</span>,<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str);
<a name="l00208"></a>00208   }
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 <span class="preprocessor">#undef ostr</span>
<a name="l00211"></a>00211 <span class="preprocessor"></span><span class="preprocessor">#define ostr &quot;-psolve_ksp_atol&quot;</span>
<a name="l00212"></a>00212 <span class="preprocessor"></span>  ierr = PetscOptionsGetString(PETSC_NULL,<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str,256,&amp;flg);CHKERRQ(ierr);
<a name="l00213"></a>00213   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00214"></a>00214     sprintf(str,<span class="stringliteral">&quot;1e-7&quot;</span>);
<a name="l00215"></a>00215     PetscOptionsSetValue(<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str);
<a name="l00216"></a>00216     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Option %s not found, using default value %s!\n&quot;</span>,<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str);
<a name="l00217"></a>00217   }
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 <span class="preprocessor">#undef ostr</span>
<a name="l00220"></a>00220 <span class="preprocessor"></span><span class="preprocessor">#define ostr &quot;-psolve_ksp_rtol&quot;</span>
<a name="l00221"></a>00221 <span class="preprocessor"></span>  ierr = PetscOptionsGetString(PETSC_NULL,<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str,256,&amp;flg);CHKERRQ(ierr);
<a name="l00222"></a>00222   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00223"></a>00223     sprintf(str,<span class="stringliteral">&quot;0.01&quot;</span>);
<a name="l00224"></a>00224     PetscOptionsSetValue(<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str);
<a name="l00225"></a>00225     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Option %s not found, using default value %s!\n&quot;</span>,<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str);
<a name="l00226"></a>00226   }
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 <span class="preprocessor">#undef ostr</span>
<a name="l00229"></a>00229 <span class="preprocessor"></span><span class="preprocessor">#define ostr &quot;-psolve_ksp_divtol&quot;</span>
<a name="l00230"></a>00230 <span class="preprocessor"></span>  ierr = PetscOptionsGetString(PETSC_NULL,<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str,256,&amp;flg);CHKERRQ(ierr);
<a name="l00231"></a>00231   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00232"></a>00232     sprintf(str,<span class="stringliteral">&quot;100&quot;</span>);
<a name="l00233"></a>00233     PetscOptionsSetValue(<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str);
<a name="l00234"></a>00234     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Option %s not found, using default value %s!\n&quot;</span>,<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str);
<a name="l00235"></a>00235   }
<a name="l00236"></a>00236 
<a name="l00237"></a>00237   <span class="keywordflow">if</span> (size&gt;1) {
<a name="l00238"></a>00238     <span class="comment">/* by default use BlockJacobi preconditioner */</span>
<a name="l00239"></a>00239 <span class="preprocessor">#undef ostr</span>
<a name="l00240"></a>00240 <span class="preprocessor"></span><span class="preprocessor">#define ostr &quot;-psolve_pc_type&quot;</span>
<a name="l00241"></a>00241 <span class="preprocessor"></span>    ierr = PetscOptionsGetString(PETSC_NULL,<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str,256,&amp;flg);CHKERRQ(ierr);
<a name="l00242"></a>00242     <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00243"></a>00243       sprintf(str,<span class="stringliteral">&quot;bjacobi&quot;</span>);
<a name="l00244"></a>00244       PetscOptionsSetValue(<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str);
<a name="l00245"></a>00245       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Option %s not found, using default value %s!\n&quot;</span>,<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str);
<a name="l00246"></a>00246     }
<a name="l00247"></a>00247 
<a name="l00248"></a>00248     <span class="comment">/* by default use ILU preconditioner on subblocks */</span>
<a name="l00249"></a>00249 <span class="preprocessor">#undef ostr</span>
<a name="l00250"></a>00250 <span class="preprocessor"></span><span class="preprocessor">#define ostr &quot;-psolve_sub_pc_type&quot;</span>
<a name="l00251"></a>00251 <span class="preprocessor"></span>    ierr = PetscOptionsGetString(PETSC_NULL,<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str,256,&amp;flg);CHKERRQ(ierr);
<a name="l00252"></a>00252     <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00253"></a>00253       sprintf(str,<span class="stringliteral">&quot;ilu&quot;</span>);
<a name="l00254"></a>00254       PetscOptionsSetValue(<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str);
<a name="l00255"></a>00255       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Option %s not found, using default value %s!\n&quot;</span>,<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str);
<a name="l00256"></a>00256     }
<a name="l00257"></a>00257 
<a name="l00258"></a>00258     <span class="comment">/* by default use Manteuffel shift */</span>
<a name="l00259"></a>00259 <span class="comment">/*</span>
<a name="l00260"></a>00260 <span class="comment">#undef ostr</span>
<a name="l00261"></a>00261 <span class="comment">#define ostr &quot;-psolve_sub_pc_factor_shift_positive_definite&quot;</span>
<a name="l00262"></a>00262 <span class="comment">    ierr = PetscOptionsGetString(PETSC_NULL,ostr,str,256,&amp;flg);CHKERRQ(ierr);</span>
<a name="l00263"></a>00263 <span class="comment">    if (flg!=PETSC_TRUE) {</span>
<a name="l00264"></a>00264 <span class="comment">      sprintf(str,&quot;1&quot;);</span>
<a name="l00265"></a>00265 <span class="comment">      PetscOptionsSetValue(ostr,str);</span>
<a name="l00266"></a>00266 <span class="comment">      PetscPrintf(PETSC_COMM_WORLD,&quot;Option %s not found, using default value %s!\n&quot;,ostr,str);</span>
<a name="l00267"></a>00267 <span class="comment">    }</span>
<a name="l00268"></a>00268 <span class="comment">*/</span>
<a name="l00269"></a>00269   }
<a name="l00270"></a>00270   <span class="keywordflow">else</span> {
<a name="l00271"></a>00271     <span class="comment">/* by default use ILU preconditioner */</span>
<a name="l00272"></a>00272 <span class="preprocessor">#undef ostr</span>
<a name="l00273"></a>00273 <span class="preprocessor"></span><span class="preprocessor">#define ostr &quot;-psolve_pc_type&quot;</span>
<a name="l00274"></a>00274 <span class="preprocessor"></span>    ierr = PetscOptionsGetString(PETSC_NULL,<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str,256,&amp;flg);CHKERRQ(ierr);
<a name="l00275"></a>00275     <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00276"></a>00276       sprintf(str,<span class="stringliteral">&quot;ilu&quot;</span>);
<a name="l00277"></a>00277       PetscOptionsSetValue(<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str);
<a name="l00278"></a>00278       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Option %s not found, using default value %s!\n&quot;</span>,<a class="code" href="precond_8c.html#a5fa86e1232846ad4aa6cdad299c1638f">ostr</a>,str);
<a name="l00279"></a>00279     }
<a name="l00280"></a>00280 
<a name="l00281"></a>00281     <span class="comment">/* by default use Manteuffel shift */</span>
<a name="l00282"></a>00282 <span class="comment">/*</span>
<a name="l00283"></a>00283 <span class="comment">#undef ostr</span>
<a name="l00284"></a>00284 <span class="comment">#define ostr &quot;-psolve_pc_factor_shift_positive_definite&quot;</span>
<a name="l00285"></a>00285 <span class="comment">    ierr = PetscOptionsGetString(PETSC_NULL,ostr,str,256,&amp;flg);CHKERRQ(ierr);</span>
<a name="l00286"></a>00286 <span class="comment">    if (flg!=PETSC_TRUE) {</span>
<a name="l00287"></a>00287 <span class="comment">      sprintf(str,&quot;1&quot;);</span>
<a name="l00288"></a>00288 <span class="comment">      PetscOptionsSetValue(ostr,str);</span>
<a name="l00289"></a>00289 <span class="comment">      PetscPrintf(PETSC_COMM_WORLD,&quot;Option %s not found, using default value %s!\n&quot;,ostr,str);</span>
<a name="l00290"></a>00290 <span class="comment">    }</span>
<a name="l00291"></a>00291 <span class="comment">*/</span>
<a name="l00292"></a>00292   }
<a name="l00293"></a>00293 
<a name="l00294"></a>00294   <span class="comment">/* use prefix for options */</span>
<a name="l00295"></a>00295   ierr = KSPSetOptionsPrefix(ksp_Jac,<span class="stringliteral">&quot;psolve_&quot;</span>);CHKERRQ(ierr);
<a name="l00296"></a>00296 
<a name="l00297"></a>00297   <span class="comment">/* possibly override defaults with settings from user defined options */</span>
<a name="l00298"></a>00298   ierr = KSPSetFromOptions(ksp_Jac);CHKERRQ(ierr);
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 <span class="comment">/*</span>
<a name="l00301"></a>00301 <span class="comment">  ierr = KSPSetInitialGuessKnoll(ksp_Jac,PETSC_TRUE);CHKERRQ(ierr);</span>
<a name="l00302"></a>00302 <span class="comment">  ierr = KSPSetInitialGuessNonzero(ksp_Jac,PETSC_TRUE);CHKERRQ(ierr);</span>
<a name="l00303"></a>00303 <span class="comment">*/</span>
<a name="l00304"></a>00304 
<a name="l00305"></a>00305   <span class="comment">/* KSPSetUp only necessary to get more useful output from KSPView */</span>
<a name="l00306"></a>00306   <span class="comment">/* FIXME: bug(?) in PETSc 2.2.1: for size==1 leads to error &quot;Zero pivot row 0&quot; */</span>
<a name="l00307"></a>00307   <span class="keywordflow">if</span> (size&gt;1) {
<a name="l00308"></a>00308     ierr = KSPSetUp(ksp_Jac);CHKERRQ(ierr);
<a name="l00309"></a>00309   }
<a name="l00310"></a>00310 
<a name="l00311"></a>00311   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;KSP for preconditioning: P*z=r:\n&quot;</span>);
<a name="l00312"></a>00312 <span class="preprocessor">#if defined(SUPERLU)</span>
<a name="l00313"></a>00313 <span class="preprocessor"></span>  PetscReal rtol,atol,divtol;
<a name="l00314"></a>00314   <span class="keywordtype">int</span> maxits;
<a name="l00315"></a>00315   ierr = KSPGetTolerances(ksp_Jac,&amp;rtol,&amp;atol,&amp;divtol,&amp;maxits);CHKERRQ(ierr);
<a name="l00316"></a>00316   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;rtol: %g atol: %g divtol: %g maxits: %i\n&quot;</span>,
<a name="l00317"></a>00317     rtol,atol,divtol,maxits
<a name="l00318"></a>00318   );
<a name="l00319"></a>00319 <span class="preprocessor">#else</span>
<a name="l00320"></a>00320 <span class="preprocessor"></span>  ierr = KSPView(ksp_Jac,PETSC_VIEWER_STDOUT_WORLD);CHKERRQ(ierr);
<a name="l00321"></a>00321 <span class="preprocessor">#endif</span>
<a name="l00322"></a>00322 <span class="preprocessor"></span>
<a name="l00323"></a>00323   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00324"></a>00324 }
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 
<a name="l00327"></a><a class="code" href="precond_8c.html#a8cdc0d7af89d96e9d57fc6c0f791331f">00327</a> <span class="keywordtype">int</span> <a class="code" href="precond_8c.html#a8cdc0d7af89d96e9d57fc6c0f791331f">Precond</a>(realtype t,N_Vector y,N_Vector fy,booleantype jok,booleantype *jcurPtr,realtype gamma,<span class="keywordtype">void</span> *P_data,N_Vector vtemp1,N_Vector vtemp2,N_Vector vtemp3)
<a name="l00328"></a>00328 {
<a name="l00329"></a>00329   <a class="code" href="structGridData.html">GridData</a>     *gdata = (<a class="code" href="structGridData.html">GridData</a>*)P_data;
<a name="l00330"></a>00330   MatStructure str = DIFFERENT_NONZERO_PATTERN;
<a name="l00331"></a>00331 
<a name="l00332"></a>00332   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00333"></a>00333 
<a name="l00334"></a>00334   <span class="comment">/* jok - TRUE means reuse current Jacobian else recompute Jacobian */</span>
<a name="l00335"></a>00335   <span class="keywordflow">if</span> (jok) {
<a name="l00336"></a>00336     ierr     = MatCopy(vode_pmat,vode_Jac,SAME_NONZERO_PATTERN);CHKERRQ(ierr);
<a name="l00337"></a>00337     str      = SAME_NONZERO_PATTERN;
<a name="l00338"></a>00338     *jcurPtr = FALSE;
<a name="l00339"></a>00339   } <span class="keywordflow">else</span> {
<a name="l00340"></a>00340     <span class="comment">/* make PETSc vector tmpy point to PVODE vector y */</span>
<a name="l00341"></a>00341 <span class="preprocessor">#ifdef UNIPROC</span>
<a name="l00342"></a>00342 <span class="preprocessor"></span>    ierr = VecPlaceArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,NV_DATA_S(y));CHKERRQ(ierr);
<a name="l00343"></a>00343 <span class="preprocessor">#else</span>
<a name="l00344"></a>00344 <span class="preprocessor"></span>    ierr = VecPlaceArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,NV_DATA_P(y));CHKERRQ(ierr);
<a name="l00345"></a>00345 <span class="preprocessor">#endif</span>
<a name="l00346"></a>00346 <span class="preprocessor"></span>
<a name="l00347"></a>00347     <span class="comment">/* TODO: make Htot not calculate demag - we don&#39;t use it for Jacobian, could save (a little) time */</span>
<a name="l00348"></a>00348     ierr = <a class="code" href="field_8h.html#ab9d30ce64708afeca163280386deb654">Htot</a>(gdata);CHKERRQ(ierr);
<a name="l00349"></a>00349 
<a name="l00350"></a>00350     <span class="comment">/* compute the Jacobian */</span>
<a name="l00351"></a>00351     ierr = <a class="code" href="llg_8h.html#a35010647607c93a40bdab3e86041714f">myLLGJacobian</a>(PETSC_NULL,gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;vode_Jac,&amp;vode_Jac,&amp;str,gdata);CHKERRQ(ierr);
<a name="l00352"></a>00352 
<a name="l00353"></a>00353     ierr = VecResetArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);CHKERRQ(ierr);
<a name="l00354"></a>00354 
<a name="l00355"></a>00355     <span class="comment">/* copy the Jacobian matrix */</span>
<a name="l00356"></a>00356     ierr = MatCopy(vode_Jac,vode_pmat,SAME_NONZERO_PATTERN);CHKERRQ(ierr);
<a name="l00357"></a>00357 
<a name="l00358"></a>00358     *jcurPtr = TRUE;
<a name="l00359"></a>00359   }
<a name="l00360"></a>00360 
<a name="l00361"></a>00361   <span class="comment">/* construct I-gamma*Jac  */</span>
<a name="l00362"></a>00362 
<a name="l00363"></a>00363   ierr = MatScale(vode_Jac,-gamma);CHKERRQ(ierr);
<a name="l00364"></a>00364   ierr = MatShift(vode_Jac,1.0);CHKERRQ(ierr);
<a name="l00365"></a>00365 
<a name="l00366"></a>00366   ierr = KSPSetOperators(ksp_Jac,vode_Jac,vode_Jac,str);CHKERRQ(ierr);
<a name="l00367"></a>00367 
<a name="l00368"></a>00368   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00369"></a>00369 }
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 
<a name="l00372"></a>00372 <span class="comment">/* adapted from $PETSC_DIR/src/ts/impls/implicit/pvode/petscpvode.c */</span>
<a name="l00373"></a>00373 
<a name="l00374"></a><a class="code" href="precond_8c.html#a26a82305d86917d32992af0031acd675">00374</a> <span class="keywordtype">int</span> <a class="code" href="precond_8c.html#a26a82305d86917d32992af0031acd675">PSolve</a>(realtype t,N_Vector y,N_Vector fy,N_Vector r,N_Vector z,realtype gamma,realtype delta,<span class="keywordtype">int</span> lr,<span class="keywordtype">void</span> *P_data,N_Vector vtemp)
<a name="l00375"></a>00375 {
<a name="l00376"></a>00376   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00377"></a>00377 
<a name="l00378"></a>00378   <span class="comment">/* as defined in call to CVSpgmr in pvode_init: 1==left, 2==right */</span>
<a name="l00379"></a>00379   assert(lr==1);
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 <span class="preprocessor">#ifdef UNIPROC</span>
<a name="l00382"></a>00382 <span class="preprocessor"></span>  ierr = VecPlaceArray(vode_w1,NV_DATA_S(r));CHKERRQ(ierr);
<a name="l00383"></a>00383   ierr = VecPlaceArray(vode_w2,NV_DATA_S(z));CHKERRQ(ierr);
<a name="l00384"></a>00384 <span class="preprocessor">#else</span>
<a name="l00385"></a>00385 <span class="preprocessor"></span>  ierr = VecPlaceArray(vode_w1,NV_DATA_P(r));CHKERRQ(ierr);
<a name="l00386"></a>00386   ierr = VecPlaceArray(vode_w2,NV_DATA_P(z));CHKERRQ(ierr);
<a name="l00387"></a>00387 <span class="preprocessor">#endif</span>
<a name="l00388"></a>00388 <span class="preprocessor"></span>
<a name="l00389"></a>00389 <span class="comment">/* no difference in performance visible with mumag std prob. #4</span>
<a name="l00390"></a>00390 <span class="comment">   between abstol=0.1*delta*abstol and reltol=0.01</span>
<a name="l00391"></a>00391 <span class="comment">   because just 1 interation is usually sufficient</span>
<a name="l00392"></a>00392 <span class="comment">   (except if the Jacobian has been recalculated)</span>
<a name="l00393"></a>00393 <span class="comment"></span>
<a name="l00394"></a>00394 <span class="comment">  KSP ksp_Jac;</span>
<a name="l00395"></a>00395 <span class="comment">  ierr = KSPSetTolerances(ksp_Jac,0.01,0.0,PETSC_DEFAULT,PETSC_DEFAULT);CHKERRQ(ierr);</span>
<a name="l00396"></a>00396 <span class="comment"></span>
<a name="l00397"></a>00397 <span class="comment">  PetscInfo3(0,&quot;set atol to: 0.1*delta*ewt[0]=%g*%g=%g\n&quot;,</span>
<a name="l00398"></a>00398 <span class="comment">    delta,NV_DATA_P(ewt)[0],0.1*delta*NV_DATA_P(ewt)[0]</span>
<a name="l00399"></a>00399 <span class="comment">  );</span>
<a name="l00400"></a>00400 <span class="comment">  ierr = KSPSetTolerances(ksp_Jac,0.0,0.1*delta*NV_DATA_P(ewt)[0],PETSC_DEFAULT,PETSC_DEFAULT);CHKERRQ(ierr);</span>
<a name="l00401"></a>00401 <span class="comment">*/</span>
<a name="l00402"></a>00402 
<a name="l00403"></a>00403 <span class="comment">/* TODO: useful/necessary before every call to KSPSolve?</span>
<a name="l00404"></a>00404 <span class="comment">*/</span>
<a name="l00405"></a>00405 <span class="comment">/*</span>
<a name="l00406"></a>00406 <span class="comment">  ierr = KSPSetInitialGuessKnoll(ksp_Jac,PETSC_TRUE);CHKERRQ(ierr);</span>
<a name="l00407"></a>00407 <span class="comment">  ierr = KSPSetInitialGuessNonzero(ksp_Jac,PETSC_TRUE);CHKERRQ(ierr);</span>
<a name="l00408"></a>00408 <span class="comment">*/</span>
<a name="l00409"></a>00409   <span class="keywordtype">int</span> its1;
<a name="l00410"></a>00410   ierr = KSPSolve(ksp_Jac,vode_w1,vode_w2);CHKERRQ(ierr);
<a name="l00411"></a>00411 
<a name="l00412"></a>00412   ierr = VecResetArray(vode_w1);CHKERRQ(ierr);
<a name="l00413"></a>00413   ierr = VecResetArray(vode_w2);CHKERRQ(ierr);
<a name="l00414"></a>00414 
<a name="l00415"></a>00415   ierr = KSPGetIterationNumber(ksp_Jac,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;its1);CHKERRQ(ierr);
<a name="l00416"></a>00416   KSPConvergedReason reason;
<a name="l00417"></a>00417   ierr = KSPGetConvergedReason(ksp_Jac,&amp;reason);CHKERRQ(ierr);
<a name="l00418"></a>00418 
<a name="l00419"></a>00419   ierr = PetscGetTime(&amp;t_t2);CHKERRQ(ierr);
<a name="l00420"></a>00420   PetscInfo2(0,<span class="stringliteral">&quot;timing: %s took %g s\n&quot;</span>,<a class="code" href="griddata_8h.html#ae60511a9aa5cbf216a00a1bb81006bc5">__FUNCT__</a>,t_t2-t_t1);
<a name="l00421"></a>00421   PetscInfo2(0,<span class="stringliteral">&quot;psolve: %i its, reason: %i\n&quot;</span>,its1,reason);
<a name="l00422"></a>00422   <span class="keywordflow">if</span> (reason&lt;0) {
<a name="l00423"></a>00423     PetscReal rnorm;
<a name="l00424"></a>00424 
<a name="l00425"></a>00425     ierr = KSPGetResidualNorm(ksp_Jac,&amp;rnorm);CHKERRQ(ierr);
<a name="l00426"></a>00426     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00427"></a>00427       <span class="stringliteral">&quot;Warning: psolve: KSP did not converge - reason: %i, rnorm: %g, its: %i\n&quot;</span>,
<a name="l00428"></a>00428       reason,rnorm,its1
<a name="l00429"></a>00429     );
<a name="l00430"></a>00430   }
<a name="l00431"></a>00431 
<a name="l00432"></a>00432   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00433"></a>00433 }
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 
<a name="l00436"></a><a class="code" href="precond_8c.html#a2a797df3786fb3caa3a618c1a39d2cc9">00436</a> <span class="keywordtype">int</span> <a class="code" href="precond_8c.html#a2a797df3786fb3caa3a618c1a39d2cc9">Jtimes</a>(N_Vector v,N_Vector Jv,realtype t,N_Vector y,N_Vector fy,<span class="keywordtype">void</span> *jac_data,N_Vector tmp)
<a name="l00437"></a>00437 {
<a name="l00438"></a>00438   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 <span class="preprocessor">#ifdef UNIPROC</span>
<a name="l00441"></a>00441 <span class="preprocessor"></span>  ierr = VecPlaceArray(vode_w1,NV_DATA_S(v));CHKERRQ(ierr);
<a name="l00442"></a>00442   ierr = VecPlaceArray(vode_w2,NV_DATA_S(Jv));CHKERRQ(ierr);
<a name="l00443"></a>00443 <span class="preprocessor">#else</span>
<a name="l00444"></a>00444 <span class="preprocessor"></span>  ierr = VecPlaceArray(vode_w1,NV_DATA_P(v));CHKERRQ(ierr);
<a name="l00445"></a>00445   ierr = VecPlaceArray(vode_w2,NV_DATA_P(Jv));CHKERRQ(ierr);
<a name="l00446"></a>00446 <span class="preprocessor">#endif</span>
<a name="l00447"></a>00447 <span class="preprocessor"></span>
<a name="l00448"></a>00448   ierr = MatMult(vode_pmat,vode_w1,vode_w2);CHKERRQ(ierr);
<a name="l00449"></a>00449 
<a name="l00450"></a>00450   ierr = VecResetArray(vode_w1);CHKERRQ(ierr);
<a name="l00451"></a>00451   ierr = VecResetArray(vode_w2);CHKERRQ(ierr);
<a name="l00452"></a>00452 
<a name="l00453"></a>00453   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00454"></a>00454 }
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

